module     p3_uubar_emepg_d25h3l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Z1jet/1.4/Virtual/p
   ! 3_uubar_emepg/helicity3/d25h3l1d.f90
   ! generator: haggies (1.1)
   use p3_uubar_emepg_config, only: ki
   use p3_uubar_emepg_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d25
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2) result(numerator)
      use p3_uubar_emepg_globalsl1, only: epspow
      use p3_uubar_emepg_kinematics
      use p3_uubar_emepg_abbrevh3
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift(:) = 0.0_ki
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(deg.eq.0) then
         numerator = abb25n12
         return
      end if
      t1 = spvak2k1(iv1)
      t2 = spvak2k5(iv1)
      if(deg.eq.1) then
         numerator = (k1(iv1)*abb25n15+k2(iv1)*abb25n17+k5(iv1)*abb25n17+spvak2k&
         &4(iv1)*abb25n19+t1*abb25n18+t2*abb25n14)
         return
      end if
      t3 = spvak3k4(iv2)
      t4 = spvak3k4(iv1)
      if(deg.eq.2) then
         numerator = ((2.0_ki)*d(iv1,iv2)*abb25n16+spvak2k1(iv2)*t4*abb25n20+spv&
         &ak2k5(iv2)*t4*abb25n13+t1*t3*abb25n20+t2*t3*abb25n13)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d25:
   subroutine     reconstruct_d25(coeffs)
      use p3_uubar_emepg_groups, only: tensrec_info_group0
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group0), intent(out) :: coeffs
      ! rank 2 case:
      !---[# reconstruct coeffs%coeffs_25:
      coeffs%coeffs_25%c0 = derivative(czip)
      coeffs%coeffs_25%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_25%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_25%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_25%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_25%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_25%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_25%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_25%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_25%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_25%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_25%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_25%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_25%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_25%c2(6,1) = derivative(czip,3,4)
      !---#] reconstruct coeffs%coeffs_25:
   end subroutine reconstruct_d25
!---#] subroutine reconstruct_d25:
end module p3_uubar_emepg_d25h3l1d
